OAMStuff:
db $80,$84,$88,$8C,$B4,$B8,$BC,$C0,$C4,$C8,$CC,$D0,$D4,$D8,$DC,$E4,$E8,$EC,$F0,$F4

Main:;The code always starts at this label in all sprites.

	JSR Graphics
	LDA $9D
	BEQ .cont
	RTS
.cont
	JSR direccionGrafica
	JSR colisionMario
	JSR movement
RTS	

direccionGrafica:

	LDA $13
	AND #$03
	BNE .ret
	
	LDA $1E66,y
	BEQ .ret
	
	INC A
	STA $1E66,y
	CMP #$05
	BCS .kill
.ret
	RTS
.kill
	LDA #$00
	STA $1892,y
	RTS

;detecta la colision con mario	
colisionMario:

	LDA $1E66,y
	BNE .ret

	JSR spriteFirst

	JSR MarioSecond
	
	LDA #$000A
	STA $08
	LDX $19
	BNE .big
	LDA #$0000
	BRA .small
.big
	LDA #$0004
.small
	STA $0A
	LDA #$000E
	STA $0C
	LDX $187A
	BNE .yosho1
	LDA #$0014
	STA $0E
	BRA .startFirstHitbox
.yosho1
	LDA #$0022
	STA $0E	
.startFirstHitbox
	JSR colision
	BCC .ret
	JSR daniarMario
.ret
	RTS
	
daniarMario:
	LDA $1497
	BNE .ret	
	LDA $187A
	BNE .loseYoshi
	LDA #$00
	STA $0F72,y
	STA $0F86,y
	STA $0F5E,y
	STA $1E52,y
	LDA #$01
	STA $1E66,y
	JSL $00F5B7
.ret
	RTS
.loseYoshi
	LDA #$00
	STA $0F72,y
	STA $0F86,y
	STA $0F5E,y
	STA $1E52,y
	LDA #$01
	STA $1E66,y
	JSR LOSEYOSHI
	RTS
	
vel: db $20,$E0
LOSEYOSHI:	
	LDA $187A
	BEQ NOYOSHI
	PHY
	PHX
	LDX $18E2
	LDA #$10
	STA $163D,x
	LDA #$03
	STA $1DFA
	LDA #$13
	STA $1DFC
	LDA #$02
	STA $C1,x
	STZ $187A
	STZ $0DC1
	LDA #$C0
	STA $7D
	STZ $7B
	LDY $157B,x
	PHX
	TYX
	LDA vel,x
	PLX
	STA $B5,x
	STZ $1593,x
	STZ $151B,x
	STZ $18AE
	LDA #$30
	STA $1497
	PLX
	PLY
NOYOSHI:
	RTS
	
spriteFirst:

	LDA $1E16,y
	STA $00 ;set the positions of the sprite indexed by y
	LDA $1E3E,y
	STA $01
	LDA $1E02,y
	STA $02
	LDA $1E2A,y
	STA $03
	RTS
	
MarioSecond:
	REP #$20
	LDA $94 ;set the mario positions
	STA $04
	LDA $96
	STA $06
	RTS
	
colision:
	
	LDA $00
	CLC
	ADC $08
	CMP $04
	BCC .ret 
	
	LDA $02
	CLC
	ADC $0A
	CMP $06
	BCC .ret
	
	LDA $04
	CLC
	ADC $0C
	CMP $00
	BCC .ret
	
	LDA $06
	CLC
	ADC $0E
	CMP $02
	BCC .ret
	
	SEP #$20	
	SEC
	RTS
	
.ret
	SEP #$20
	CLC
	RTS

;0F72 = xvel
;0F86 = xvelAcum
;0F5E = yvel
;1E52 = yvelacum
movement:

	LDA $0F72,y
	STA $00
	
	LDA $0F86,y
	STA $01
	
	LDA $1E16,y
	STA $02
	
	LDA $1E3E,y
	STA $03
	
	JSR actualizarVelocidad	
	
	LDA $01
	STA $0F86,y
	
	LDA $02
	STA $1E16,y
	
	LDA $03
	STA $1E3E,y
	
	LDA $0F5E,y
	STA $00
	
	LDA $1E52,y
	STA $01
	
	LDA $1E02,y
	STA $02
	
	LDA $1E2A,y
	STA $03	
	
	JSR actualizarVelocidad	

	LDA $01
	STA $1E52,y
	
	LDA $02
	STA $1E02,y
	
	LDA $03	
	STA $1E2A,y
	
	RTS
	
;00 velocidad
;01 fraccion de velocidad
;02 posicion low
;03 posicion high
;04 cantidad de pixeles que se movio en esta direccion, util para sprites en los que mario se puede subir
;rutina ripeada del smw, solo le hice algunas modificaciones para que sea usada para cualquier sprite
actualizarVelocidad:

	PHY

	LDA $00		;Carga la velocidad 
	BEQ .ret				;si es 0 retorna 
	
	ASL							; \  
	ASL							;  |Multica la velocidad por 16 
	ASL							;  | 
	ASL							; /  
	CLC							; \  
	ADC $01					;  |incrementa la fraccion de velocidad 
	STA $01					; /  
	PHP                       
	PHP                       
	LDY #$00                
	LDA $00		;carga denuevo la velocidad
	LSR							; \  
	LSR							;  |la divide por 16 
	LSR							;  | 
	LSR							; /  
	CMP #$08                
	BCC +         
	ORA #$F0                
	DEY  
	
+

	PLP                       
	PHA                       
	ADC $02			; \ agrega la velocidad dividida 16 al low byte de la posicion 
	STA $02			; /  
	TYA                       
	ADC $03     
	STA $03         ;agrega una cantidad 0 1 o -1 a el high byte de la posicion dependiendo el borde que esta pasando o sino atraviesa borde
	PLA                       
	PLP                       
	ADC #$00  
.ret
	
	STA $04         ;almacena la cantidad de pixeles que se movio en esta direccion

	PLY
	RTS							; retorna	

tiles: db $65,$EA,$EB,$FA,$FB
prope: db $25,$2D,$2D,$2D,$2D
Graphics:
	LDA $1E16,y
	STA $00
	
	LDA $1E3E,y
	STA $01
	
	LDA $1E02,y
	STA $02
	
	LDA $1E2A,y
	STA $03
	
	LDA #$00
	STA $04
	
	REP #$20
	
	LDA $00
	CLC
	ADC #$0004
	SEC
	SBC $1A
	STA $00
	CMP #$0140
	BCS .ret
	CMP #$FFC0
	BCC .xcont
	LDX #$01
	STX $04
.xcont
	SEC
	SBC #$0100
	CMP #$0040
	BCS .yPos
	LDX #$01
	STX $04
.yPos
	LDA $02
	SEC
	SBC $1C
	STA $02
	CMP #$00E0
	BCS .ret
	CMP #$FFC0
	BCC .ycont
	LDX #$01
	STX $04
.ycont
	SEC
	SBC #$0100
	CMP #$0040
	BCS .start
	LDX #$01
	STX $04	

.start
	SEP #$20	
	LDA $1E66,y
	TAX
	PHY
	LDA OAMStuff,y
	TAY

	LDA $00
	STA $0200,y			; /ponemos el sprite en pantalla en la posicion correcta
	LDA $02
	STA $0201,y			; /
	LDA tiles,x		; \ 
	STA $0202,y                     ; / 
	LDA prope,x
	STA $0203,y	
	
	TYA
	LSR
	LSR	
	TAY
	LDA $04;ponemos el tamano del grafico con su modalidad
	STA $0420,y
	PLY
	RTS
.ret
	SEP #$20
	LDA #$00
	STA $1892,y
	RTS